#!/usr/bin/env python

'''
Script to start the removehost playbook
=======================================
'''

import os
import argparse
from subprocess import call

parser = argparse.ArgumentParser(description='Launch the Ansible playbook removehost')
parser.add_argument('host',
                    help='Name of the host to be removed')

parser.add_argument('--cloud', action='store', choices=['ec2', 'jiffybox'],
                    help='The cloud provider')

args, extras = parser.parse_known_args()

path = os.path.dirname(os.path.realpath(__file__)) + os.path.sep

extraVars = ['host=' + args.host]
if args.cloud:
    extraVars.append('cloud=' + args.cloud)

cmd = [path + 'ansible-playbook.sh', 'removehost', '--extra-vars=' + ' '.join(extraVars)]
for extra in extras:
    cmd.append(extra)

call(cmd)
