#!/usr/bin/env python

'''
Wrapper for the role playbook
=============================
'''

import os
import argparse
from subprocess import call

parser = argparse.ArgumentParser(description='Wrapper for the role playbook')
parser.add_argument('role',
                    help='Role to execute')
parser.add_argument('hosts',
                    help='Host name or pattern')

args, extras = parser.parse_known_args()

path = os.path.dirname(os.path.realpath(__file__)) + os.path.sep

# Start building command
cmd = [path + 'ansible-playbook.py', 'role', '--extra-vars=hosts=' + args.hosts + ' role=' + args.role]

# Append more CLI options
for extra in extras:
    cmd.append(extra)

call(cmd, cwd=path)
