#!/usr/bin/env python

'''
Wrapper for the sanity playbook
===============================
'''

import os
import argparse
from subprocess import call

parser = argparse.ArgumentParser(description='Wrapper for the sanity playbook')
parser.add_argument('mode', choices=['check', 'upgrade', 'reboot'],
                    help='Mode for the sanity play')

args, extras = parser.parse_known_args()

path = os.path.dirname(os.path.realpath(__file__)) + os.path.sep

# Start building command
cmd = [path + 'ansible-playbook.py', 'sanity', '--tags=' + args.mode]

# Append more CLI options
for extra in extras:
    cmd.append(extra)

call(cmd, cwd=path)
