#!/usr/bin/env python

'''
Setup and update the Paragon wrapper for Ansible
================================================
'''

import os
import argparse
from subprocess import call

parser = argparse.ArgumentParser(description='Wrapper for the role playbook')
parser.add_argument('company',
                    help='Name of the company in lowercase to specify the inventory')

args, extras = parser.parse_known_args()

path = os.path.dirname(os.path.realpath(__file__)) + os.path.sep

# Start building command
cmd = [path + 'ansible-playbook.py', 'setup_local', '--local', '--extra-vars=company=' + args.company]

# Append more CLI options
for extra in extras:
    cmd.append(extra)

call(cmd, cwd=path)
